#pragma once

#include <SDL_events.h>
#include <SDL_mouse.h>
#include <SDL_keycode.h>

namespace KE
{
	enum class EventType : ushort
	{
		UNDEFINED			  = SDL_FIRSTEVENT,
		QUIT				  = SDL_QUIT,
		WINDOW				  = SDL_WINDOWEVENT,
		KEY_PRESSED			  = SDL_KEYDOWN,
		KEY_RELEASED		  = SDL_KEYUP,
		MOUSE_MOTION		  = SDL_MOUSEMOTION,
		MOUSE_BUTTON_PRESSED  = SDL_MOUSEBUTTONDOWN,
		MOUSE_BUTTON_RELEASED = SDL_MOUSEBUTTONUP,
		MOUSE_WHEEL			  = SDL_MOUSEWHEEL,
		CUSTOM				  = SDL_USEREVENT,
		LAST
	};

	/*
	* How to implement custom event types
	*/
	/*enum class CustomEventType : unsigned short
	{
		CustomType1 = (unsigned short)EventType::LAST,
		CustomType2,
		CustomType3,
		LAST
	};

	enum class CustomEventType2 : unsigned short
	{
		CustomType4 = (unsigned short)CustomEventType::LAST,
		CustomType5,
		CustomType6,
		LAST
	};*/

	enum class MouseButton : uchar
	{
		UNDEFINED	  = 0,
		LEFT_BUTTON	  = SDL_BUTTON_LEFT,
		MIDDLE_BUTTON = SDL_BUTTON_MIDDLE,
		RIGHT_BUTTON  = SDL_BUTTON_RIGHT,
		SIDE_BUTTON_1 = SDL_BUTTON_X1,
		SIDE_BUTTON_2 = SDL_BUTTON_X2
	};

	enum class KeyCode : uint
	{
		UNDEFINED			  = SDLK_UNKNOWN,

		KEY_ENTER			  = SDLK_RETURN,
		KEY_ESCAPE			  = SDLK_ESCAPE,
		KEY_BACKSPACE		  = SDLK_BACKSPACE,
		KEY_TAB				  = SDLK_TAB,
		KEY_SPACE			  = SDLK_SPACE,
		KEY_EXCLAIMATION	  = SDLK_EXCLAIM,
		KEY_DOUBLE_QUOTE	  = SDLK_QUOTEDBL,
		KEY_HASHTAG			  = SDLK_HASH,
		KEY_PERCENT			  = SDLK_PERCENT,
		KEY_DOLLAR			  = SDLK_DOLLAR,
		KEY_AMPERSAND		  = SDLK_AMPERSAND,
		KEY_SINGLE_QUOTE	  = SDLK_QUOTE,
		KEY_LEFT_PARENTHESIS  = SDLK_LEFTPAREN,
		KEY_RIGHT_PARENTHESIS = SDLK_RIGHTPAREN,
		KEY_ASTERISK		  = SDLK_ASTERISK,
		KEY_PLUS			  = SDLK_PLUS,
		KEY_COMMA			  = SDLK_COMMA,
		KEY_MINUS			  = SDLK_MINUS,
		KEY_PERIOS			  = SDLK_PERIOD,
		KEY_SLASH			  = SDLK_SLASH,

		KEY_0 = SDLK_0,
		KEY_1 = SDLK_1,
		KEY_2 = SDLK_2,
		KEY_3 = SDLK_3,
		KEY_4 = SDLK_4,
		KEY_5 = SDLK_5,
		KEY_6 = SDLK_6,
		KEY_7 = SDLK_7,
		KEY_8 = SDLK_8,
		KEY_9 = SDLK_9,

		KEY_COLON     = SDLK_COLON,
		KEY_SEMICOLON = SDLK_SEMICOLON,
		KEY_LESS	  = SDLK_LESS,
		KEY_EQUALS	  = SDLK_EQUALS,
		KEY_GREATER	  = SDLK_GREATER,
		KEY_QUESTION  = SDLK_QUESTION,
		KEY_AT		  = SDLK_AT,

		KEY_LEFT_BRACKET  = SDLK_LEFTBRACKET,
		KEY_BACKSLASH	  = SDLK_BACKSLASH,
		KEY_RIGHT_BRACKET = SDLK_RIGHTBRACKET,
		KEY_CARET		  = SDLK_CARET,
		KEY_UNDERSCORE	  = SDLK_UNDERSCORE,
		KEY_BACKQUOTE	  = SDLK_BACKQUOTE,

		KEY_A = SDLK_a,
		KEY_B = SDLK_b,
		KEY_C = SDLK_c,
		KEY_D = SDLK_d,
		KEY_E = SDLK_e,
		KEY_F = SDLK_f,
		KEY_G = SDLK_g,
		KEY_H = SDLK_h,
		KEY_I = SDLK_i,
		KEY_J = SDLK_j,
		KEY_K = SDLK_k,
		KEY_L = SDLK_l,
		KEY_M = SDLK_m,
		KEY_N = SDLK_n,
		KEY_O = SDLK_o,
		KEY_P = SDLK_p,
		KEY_Q = SDLK_q,
		KEY_R = SDLK_r,
		KEY_S = SDLK_s,
		KEY_T = SDLK_t,
		KEY_U = SDLK_u,
		KEY_V = SDLK_v,
		KEY_W = SDLK_w,
		KEY_X = SDLK_x,
		KEY_Y = SDLK_y,
		KEY_Z = SDLK_z,

		KEY_CAPSLOCK	= SDLK_CAPSLOCK,
		KEY_LEFT_CTRL	= SDLK_LCTRL,
		KEY_LEFT_SHIFT	= SDLK_LSHIFT,
		KEY_LEFT_ALT	= SDLK_LALT,
		KEY_RIGHT_CTRL	= SDLK_RCTRL,
		KEY_RIGHT_SHIFT = SDLK_RSHIFT,
		KEY_RIGHT_ALT	= SDLK_RALT,

		KEY_F1	= SDLK_F1,
		KEY_F2	= SDLK_F2,
		KEY_F3	= SDLK_F3,
		KEY_F4	= SDLK_F4,
		KEY_F5	= SDLK_F5,
		KEY_F6	= SDLK_F6,
		KEY_F7	= SDLK_F7,
		KEY_F8	= SDLK_F8,
		KEY_F9	= SDLK_F9,
		KEY_F10 = SDLK_F10,
		KEY_F11 = SDLK_F11,
		KEY_F12 = SDLK_F12,

		KEY_PRINT_SCREEN = SDLK_PRINTSCREEN,
		KEY_PAUSE		 = SDLK_PAUSE,
		KEY_INSERT		 = SDLK_INSERT,
		KEY_HOME		 = SDLK_HOME,
		KEY_PAGE_UP		 = SDLK_PAGEUP,
		KEY_DELETE		 = SDLK_DELETE,
		KEY_END			 = SDLK_END,
		KEY_PAGE_DOWN	 = SDLK_PAGEDOWN,
		KEY_RIGHT		 = SDLK_RIGHT,
		KEY_LEFT		 = SDLK_LEFT,
		KEY_DOWN		 = SDLK_DOWN,
		KEY_UP			 = SDLK_UP,

		KEY_NUMPAD_DIVIDE	= SDLK_KP_DIVIDE,
		KEY_NUMPAD_MULTIPLY = SDLK_KP_MULTIPLY,
		KEY_NUMPAD_MINUS	= SDLK_KP_MINUS,
		KEY_NUMPAD_PLUS		= SDLK_KP_PLUS,
		KEY_NUMPAD_ENTER	= SDLK_KP_ENTER,
		KEY_NUMPAD_1		= SDLK_KP_1,
		KEY_NUMPAD_2		= SDLK_KP_2,
		KEY_NUMPAD_3		= SDLK_KP_3,
		KEY_NUMPAD_4		= SDLK_KP_4,
		KEY_NUMPAD_5		= SDLK_KP_5,
		KEY_NUMPAD_6		= SDLK_KP_6,
		KEY_NUMPAD_7		= SDLK_KP_7,
		KEY_NUMPAD_8		= SDLK_KP_8,
		KEY_NUMPAD_9		= SDLK_KP_9,
		KEY_NUMPAD_0		= SDLK_KP_0,
		KEY_NUMPAD_PERIOD	= SDLK_KP_PERIOD
	};

	enum class KeyMod : ushort
	{
		UNDEFINED   = KMOD_NONE,
		LEFT_SHIFT  = KMOD_LSHIFT,
		RIGHT_SHIFT = KMOD_RSHIFT,
		LEFT_CTRL	= KMOD_LCTRL,
		RIGHT_CTRL	= KMOD_RCTRL,
		LEFT_ALT	= KMOD_LALT,
		RIGHT_ALT	= KMOD_RALT
	};

	enum class WindowEventType : uchar
	{
		UNDEFINED			  = SDL_WINDOWEVENT_NONE,
		MOVED				  = SDL_WINDOWEVENT_MOVED,
		RESIZED				  = SDL_WINDOWEVENT_RESIZED,
		SIZE_CHANGED		  = SDL_WINDOWEVENT_SIZE_CHANGED,
		MINIMIZED			  = SDL_WINDOWEVENT_MINIMIZED,
		MAXIMIZED			  = SDL_WINDOWEVENT_MAXIMIZED,
		RESTORED			  = SDL_WINDOWEVENT_RESTORED,
		MOUSE_GAINED_FOCUS	  = SDL_WINDOWEVENT_ENTER,
		MOUSE_LOST_FOCUS	  = SDL_WINDOWEVENT_LEAVE,
		KEYBOARD_GAINED_FOCUS = SDL_WINDOWEVENT_FOCUS_GAINED,
		KEYBOARD_LOST_FOCUS	  = SDL_WINDOWEVENT_FOCUS_LOST,
		CLOSE				  = SDL_WINDOWEVENT_CLOSE,
		DISPLAY_CHANGED		  = SDL_WINDOWEVENT_DISPLAY_CHANGED
	};
}
